ci/freedreno: Add a test run of a few driver options.
[mesa.git] / .gitlab-ci / deqp-runner.sh
1 #!/bin/sh
2
3 set -ex
4
5 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-width=256 --deqp-surface-height=256"
6 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-type=pbuffer"
7 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-gl-config-name=rgba8888d24s8ms0"
8 DEQP_OPTIONS="$DEQP_OPTIONS --deqp-visibility=hidden"
9
10 # It would be nice to be able to enable the watchdog, so that hangs in a test
11 # don't need to wait the full hour for the run to time out. However, some
12 # shaders end up taking long enough to compile
13 # (dEQP-GLES31.functional.ubo.random.all_per_block_buffers.20 for example)
14 # that they'll sporadically trigger the watchdog.
15 #DEQP_OPTIONS="$DEQP_OPTIONS --deqp-watchdog=enable"
16
17 if [ -z "$DEQP_VER" ]; then
18 echo 'DEQP_VER must be set to something like "gles2", "gles31" or "vk" for the test run'
19 exit 1
20 fi
21
22 if [ "$DEQP_VER" = "vk" ]; then
23 if [ -z "$VK_DRIVER" ]; then
24 echo 'VK_DRIVER must be to something like "radeon" or "intel" for the test run'
25 exit 1
26 fi
27 fi
28
29 if [ -z "$DEQP_SKIPS" ]; then
30 echo 'DEQP_SKIPS must be set to something like "deqp-default-skips.txt"'
31 exit 1
32 fi
33
34 INSTALL=`pwd`/install
35
36 # Set up the driver environment.
37 export LD_LIBRARY_PATH=`pwd`/install/lib/
38 export EGL_PLATFORM=surfaceless
39 export VK_ICD_FILENAMES=`pwd`/install/share/vulkan/icd.d/"$VK_DRIVER"_icd.x86_64.json
40
41 # the runner was failing to look for libkms in /usr/local/lib for some reason
42 # I never figured out.
43 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib
44
45 RESULTS=`pwd`/results
46 mkdir -p $RESULTS
47
48 # Generate test case list file.
49 if [ "$DEQP_VER" = "vk" ]; then
50 cp /deqp/mustpass/vk-master.txt /tmp/case-list.txt
51 DEQP=/deqp/external/vulkancts/modules/vulkan/deqp-vk
52 else
53 cp /deqp/mustpass/$DEQP_VER-master.txt /tmp/case-list.txt
54 DEQP=/deqp/modules/$DEQP_VER/deqp-$DEQP_VER
55 fi
56
57 # If the job is parallel, take the corresponding fraction of the caselist.
58 # Note: N~M is a gnu sed extension to match every nth line (first line is #1).
59 if [ -n "$CI_NODE_INDEX" ]; then
60 sed -ni $CI_NODE_INDEX~$CI_NODE_TOTAL"p" /tmp/case-list.txt
61 fi
62
63 if [ -n "$DEQP_CASELIST_FILTER" ]; then
64 sed -i "/$DEQP_CASELIST_FILTER/p" /tmp/case-list.txt
65 fi
66
67 if [ ! -s /tmp/case-list.txt ]; then
68 echo "Caselist generation failed"
69 exit 1
70 fi
71
72 if [ -n "$DEQP_EXPECTED_FAILS" ]; then
73 XFAIL="--xfail-list $INSTALL/$DEQP_EXPECTED_FAILS"
74 fi
75
76 set +e
77
78 if [ -n "$DEQP_PARALLEL" ]; then
79 JOB="--job $DEQP_PARALLEL"
80 fi
81
82 run_cts() {
83 deqp=$1
84 caselist=$2
85 output=$3
86 deqp-runner \
87 --deqp $deqp \
88 --output $output \
89 --caselist $caselist \
90 --exclude-list $INSTALL/$DEQP_SKIPS \
91 --compact-display false \
92 $XFAIL \
93 $JOB \
94 --allow-flakes true \
95 $DEQP_RUNNER_OPTIONS \
96 -- \
97 $DEQP_OPTIONS
98 }
99
100 report_flakes() {
101 if [ -z "$FLAKES_CHANNEL" ]; then
102 return 0
103 fi
104 flakes=$1
105 bot="$CI_RUNNER_DESCRIPTION-$CI_PIPELINE_ID"
106 channel="$FLAKES_CHANNEL"
107 (
108 echo NICK $bot
109 echo USER $bot unused unused :Gitlab CI Notifier
110 sleep 10
111 echo "JOIN $channel"
112 sleep 1
113 desc="Flakes detected in job: $CI_JOB_URL on $CI_RUNNER_DESCRIPTION"
114 if [ -n "CI_MERGE_REQUEST_SOURCE_BRANCH_NAME" ]; then
115 desc="$desc on branch $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME ($CI_MERGE_REQUEST_TITLE)"
116 fi
117 echo "PRIVMSG $channel :$desc"
118 for flake in `cat $flakes`; do
119 echo "PRIVMSG $channel :$flake"
120 done
121 echo "PRIVMSG $channel :See $CI_JOB_URL/artifacts/browse/results/"
122 echo "QUIT"
123 ) | nc irc.freenode.net 6667 > /dev/null
124
125 }
126
127 extract_xml_result() {
128 testcase=$1
129 shift 1
130 qpas=$*
131 start="#beginTestCaseResult $testcase"
132 for qpa in $qpas; do
133 while IFS= read -r line; do
134 if [ "$line" = "$start" ]; then
135 dst="$testcase.qpa"
136 echo "#beginSession" > $dst
137 echo $line >> $dst
138 while IFS= read -r line; do
139 if [ "$line" = "#endTestCaseResult" ]; then
140 echo $line >> $dst
141 echo "#endSession" >> $dst
142 /deqp/executor/testlog-to-xml $dst "$RESULTS/$testcase$DEQP_RUN_SUFFIX.xml"
143 # copy the stylesheets here so they only end up in artifacts
144 # if we have one or more result xml in artifacts
145 cp /deqp/testlog.css "$RESULTS/"
146 cp /deqp/testlog.xsl "$RESULTS/"
147 return 0
148 fi
149 echo $line >> $dst
150 done
151 return 1
152 fi
153 done < $qpa
154 done
155 }
156
157 extract_xml_results() {
158 qpas=$*
159 while IFS= read -r testcase; do
160 testcase=${testcase%,*}
161 extract_xml_result $testcase $qpas
162 done
163 }
164
165 # Generate junit results
166 generate_junit() {
167 results=$1
168 echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
169 echo "<testsuites>"
170 echo "<testsuite name=\"$DEQP_VER-$CI_NODE_INDEX\">"
171 while read line; do
172 testcase=${line%,*}
173 result=${line#*,}
174 # avoid counting Skip's in the # of tests:
175 if [ "$result" = "Skip" ]; then
176 continue;
177 fi
178 echo "<testcase name=\"$testcase\">"
179 if [ "$result" != "Pass" ]; then
180 echo "<failure type=\"$result\">"
181 echo "$result: See $CI_JOB_URL/artifacts/results/$testcase.xml"
182 echo "</failure>"
183 fi
184 echo "</testcase>"
185 done < $results
186 echo "</testsuite>"
187 echo "</testsuites>"
188 }
189
190 parse_renderer() {
191 RENDERER=`grep -A1 TestCaseResult.\*info.renderer $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
192 VERSION=`grep -A1 TestCaseResult.\*info.version $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
193 echo "Renderer: $RENDERER"
194 echo "Version: $VERSION "
195
196 if ! echo $RENDERER | grep -q $DEQP_EXPECTED_RENDERER; then
197 echo "Expected GL_RENDERER $DEQP_EXPECTED_RENDERER"
198 exit 1
199 fi
200 }
201
202 check_renderer() {
203 echo "Capturing renderer info for driver sanity checks"
204 # If you're having trouble loading your driver, uncommenting this may help
205 # debug.
206 # export EGL_LOG_LEVEL=debug
207 VERSION=`echo $DEQP_VER | tr '[a-z]' '[A-Z]'`
208 $DEQP $DEQP_OPTIONS --deqp-case=dEQP-$VERSION.info.\* --deqp-log-filename=$RESULTS/deqp-info.qpa
209 parse_renderer
210 }
211
212 # wrapper to supress +x to avoid spamming the log
213 quiet() {
214 set +x
215 "$@"
216 set -x
217 }
218
219 if [ "$GALLIUM_DRIVER" = "virpipe" ]; then
220 # deqp is to use virpipe, and virgl_test_server llvmpipe
221 export GALLIUM_DRIVER="$GALLIUM_DRIVER"
222
223 GALLIUM_DRIVER=llvmpipe \
224 GALLIVM_PERF="nopt,no_filter_hacks" \
225 VTEST_USE_EGL_SURFACELESS=1 \
226 VTEST_USE_GLES=1 \
227 virgl_test_server >$RESULTS/vtest-log.txt 2>&1 &
228
229 sleep 1
230 fi
231
232 if [ $DEQP_VER != vk ]; then
233 quiet check_renderer
234 fi
235
236 RESULTSFILE=$RESULTS/cts-runner-results$DEQP_RUN_SUFFIX.txt
237 UNEXPECTED_RESULTSFILE=$RESULTS/cts-runner-unexpected-results$DEQP_RUN_SUFFIX.txt
238 FLAKESFILE=$RESULTS/cts-runner-flakes$DEQP_RUN_SUFFIX.txt
239
240 run_cts $DEQP /tmp/case-list.txt $RESULTSFILE
241 DEQP_EXITCODE=$?
242
243 # junit is disabled, because it overloads gitlab.freedesktop.org to parse it.
244 #quiet generate_junit $RESULTSFILE > $RESULTS/results.xml
245
246 if [ $DEQP_EXITCODE -ne 0 ]; then
247 # preserve caselist files in case of failures:
248 cp /tmp/deqp_runner.*.txt $RESULTS/
249 egrep -v ",Pass|,Skip|,ExpectedFail" $RESULTSFILE > $UNEXPECTED_RESULTSFILE.txt
250
251 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
252 echo "Some unexpected results found (see cts-runner-results.txt in artifacts for full results):"
253 head -n 50 $UNEXPECTED_RESULTSFILE.txt
254
255 # Save the logs for up to the first 50 unexpected results:
256 head -n 50 $UNEXPECTED_RESULTSFILE.txt | quiet extract_xml_results /tmp/*.qpa
257 else
258 echo "Unexpected results found:"
259 cat $UNEXPECTED_RESULTSFILE.txt
260 fi
261
262 count=`wc -l $UNEXPECTED_RESULTSFILE.txt`
263
264 # Re-run fails to detect flakes. But use a small threshold, if
265 # something was fundamentally broken, we don't want to re-run
266 # the entire caselist
267 else
268 grep ",Flake" $RESULTSFILE > $FLAKESFILE
269
270 count=`wc -l $FLAKESFILE`
271 if [ $count -gt 0 ]; then
272 echo "Some flakes found (see cts-runner-flakes.txt in artifacts for full results):"
273 head -n 50 $FLAKESFILE
274
275 if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
276 # Save the logs for up to the first 50 flakes:
277 head -n 50 $FLAKESFILE | quiet extract_xml_results /tmp/*.qpa
278 fi
279
280 # Report the flakes to IRC channel for monitoring (if configured):
281 quiet report_flakes $FLAKESFILE
282 else
283 # no flakes, so clean-up:
284 rm $FLAKESFILE
285 fi
286 fi
287
288 exit $DEQP_EXITCODE